<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Task 30.10 - Login form</title>
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.2/dist/css/bootstrap.min.css"
        integrity="sha384-xOolHFLEh07PJGoPkLv1IbcEPTNtaed2xpHsD9ESMhqIYd0nLMwNLD69Npy4HI+N" crossorigin="anonymous">
    <script src="https://cdn.jsdelivr.net/npm/jquery@3.5.1/dist/jquery.slim.min.js"
        integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj"
        crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.1/dist/umd/popper.min.js"
        integrity="sha384-9/reFTGAW83EW2RDu2S0VKaIzap3H66lZH81PoYlFhbGU+6BZp6G7niu735Sk7lN"
        crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.2/dist/js/bootstrap.min.js"
        integrity="sha384-+sLIOodYLS7CIrQpBjl+C7nPvqq+FbNUBDunl/OZv93DB7Ln/533i8e/mZXLi/P+"
        crossorigin="anonymous"></script>
</head>

<body onload="onPageLoading()">
    <div class="container">
        <h1>Login form</h1>
        <br>
        <form id="form-login">
            <div class="form-group">
                <label for="input-email">Email address</label>
                <input type="email" class="form-control" id="input-email" aria-describedby="emailHelp">
                <small id="emailHelp" class="form-text text-muted">We'll never share your email with anyone
                    else.</small>
            </div>
            <div class="form-group">
                <label for="input-password">Password</label>
                <input type="password" class="form-control" id="input-password">
            </div>
            <button type="submit" class="btn btn-primary">Submit</button>
        </form>
    </div>
</body>

<script>

    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_STATUS_CREATED = 201;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gBASE_URL = "https://62458c222cfed18817229118.mockapi.io/users";
    const gBASE_URL_CONTACTS = "https://62458c222cfed18817229118.mockapi.io/contacts";

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    function onPageLoading() {
        var loginForm = document.getElementById("form-login");

        loginForm.addEventListener("submit", function (e) {
            e.preventDefault(); // bo qua submit mac dinh cua form
            console.log("form chua duoc submit");
            var vFormLogin = {
                username: "",
                password: ""
            }
            // B1 : thu thap du lieu
            thuThapDuLieuLogin(vFormLogin);

            // B2 : kiem du lieu xem co chuan khong?
            var vKetQua = kiemTraDuLieuFormLogin(vFormLogin);
            if (vKetQua) {
                //B3 : Goi API -> gửi thông tin đăng nhập lên máy chủ
                const vParams = new URLSearchParams(vFormLogin);
                // create a request
                var vXmlHttpLogin = new XMLHttpRequest();
                vXmlHttpLogin.open("GET", gBASE_URL + "?" + vParams.toString(), true);
                vXmlHttpLogin.send();
                vXmlHttpLogin.onreadystatechange =
                    function () {
                        if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {                           
                            // b4 : xu lieu du lieu tra ve
                            xuLyDuLieuTraVe(vXmlHttpLogin);
                        }
                    }

            }
        });
    }

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    function thuThapDuLieuLogin(paramForm) {
        var vInputUserName = document.getElementById("input-email");
        var vInputPassword = document.getElementById("input-password");
        paramForm.username = vInputUserName.value.trim();
        paramForm.password = vInputPassword.value.trim();
    }

    // Kiem tra du lieu form login
    // input : doi tuong Form Login
    // output : true -> khi du lieu tren form dam bao dung yeu cau; false -> khi du lieu cua form nhap khong dung dinh dang yeu cau
    function kiemTraDuLieuFormLogin(paramForm) {
        if (paramForm.username.length == 0) {
            alert("Yêu cầu nhập email đăng nhập");
            return false;
        }
        
        // kiem tra xem co dung dinh dang email hay khong?
        if (!isEmail(paramForm.username)) {
            alert("Tên đăng nhập phải có định dạng là địa chỉ email");
            return false;
        }
        if (paramForm.password.length == 0) {
            alert("Mật khẩu không được rỗng");
            return false;
        }
        return true;
    }

    function isEmail(email) {
        var pattern = /^[\w-]+(\.[\w-]+)*@([\w-]+\.)+[a-zA-Z]{2,7}$/;
        return pattern.test(email);
    }

    function xuLyDuLieuTraVe(paramXmlHttpRequest){
        var vLoginInfo = paramXmlHttpRequest.responseText;
        console.log(vLoginInfo);
    }
</script>

</html>